package hk.quantr.netbeans.riscv.window;

import hk.quantr.netbeans.riscv.asm.debugger.Simulator;
import java.awt.event.KeyEvent;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
		dtd = "-//hk.quantr.netbeans.riscv.window//Memory//EN",
		autostore = false
)
@TopComponent.Description(
		preferredID = "MemoryTopComponent",
		iconBase = "hk/quantr/netbeans/riscv/window/memory.png",
		persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "output", openAtStartup = false)
@ActionID(category = "Window", id = "hk.quantr.netbeans.riscv.window.MemoryTopComponent")
@ActionReference(path = "Menu/Window/RISCV" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
		displayName = "#CTL_MemoryAction",
		preferredID = "MemoryTopComponent"
)
@Messages({
	"CTL_MemoryAction=Memory",
	"CTL_MemoryTopComponent=Memory Window",
	"HINT_MemoryTopComponent=This is a Memory window"
})
public final class MemoryTopComponent extends TopComponent {

	public static MemoryTableModel memoryTableModel = new MemoryTableModel();

	public MemoryTopComponent() {
		initComponents();
		setName(Bundle.CTL_MemoryTopComponent());
		setToolTipText(Bundle.HINT_MemoryTopComponent());
		memoryTable.setModel(memoryTableModel);
//		memoryTable.setDefaultRenderer(String.class, new MemoryTableCellRenderer());
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        radixButtonGroup = new javax.swing.ButtonGroup();
        memoryTabbedPane = new javax.swing.JTabbedPane();
        memory = new javax.swing.JPanel();
        memoryToolBar = new javax.swing.JToolBar();
        searchMemoryTextField = new javax.swing.JTextField();
        searchMemoryButton = new javax.swing.JButton();
        binaryRadioButton = new javax.swing.JRadioButton();
        octRadioButton = new javax.swing.JRadioButton();
        decRadioButton = new javax.swing.JRadioButton();
        hexRadioButton = new javax.swing.JRadioButton();
        memoryScrollPane = new javax.swing.JScrollPane();
        memoryTable = new javax.swing.JTable();
        searchMemory = new javax.swing.JPanel();
        searchMemoryToolBar = new javax.swing.JToolBar();
        searchMemoryHexDecString = new javax.swing.JLabel();
        searchMemoryFrom = new javax.swing.JLabel();
        searchMemoryScrollPaneToolBar = new javax.swing.JScrollPane();
        searchMemoryTextPane = new javax.swing.JTextPane();
        searchMemoryComboBox = new javax.swing.JComboBox<>();
        searchMemoryTo = new javax.swing.JLabel();
        searchMemoryComboBox2 = new javax.swing.JComboBox<>();
        searchMemorySearch = new javax.swing.JButton();
        searchMemoryScrollPane = new javax.swing.JScrollPane();
        searchMemoryTable = new javax.swing.JTable();

        setLayout(new java.awt.BorderLayout());

        memory.setBackground(new java.awt.Color(255, 255, 255));
        memory.setLayout(new java.awt.BorderLayout());

        memoryToolBar.setRollover(true);

        searchMemoryTextField.setText(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemoryTextField.text")); // NOI18N
        searchMemoryTextField.setMaximumSize(new java.awt.Dimension(120, 40));
        searchMemoryTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchMemoryTextFieldActionPerformed(evt);
            }
        });
        searchMemoryTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                searchMemoryTextFieldKeyPressed(evt);
            }
        });
        memoryToolBar.add(searchMemoryTextField);

        org.openide.awt.Mnemonics.setLocalizedText(searchMemoryButton, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemoryButton.text")); // NOI18N
        searchMemoryButton.setFocusable(false);
        searchMemoryButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        searchMemoryButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        searchMemoryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchMemoryButtonActionPerformed(evt);
            }
        });
        memoryToolBar.add(searchMemoryButton);

        radixButtonGroup.add(binaryRadioButton);
        org.openide.awt.Mnemonics.setLocalizedText(binaryRadioButton, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.binaryRadioButton.text")); // NOI18N
        binaryRadioButton.setFocusable(false);
        binaryRadioButton.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        binaryRadioButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        binaryRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                binaryRadioButtonActionPerformed(evt);
            }
        });
        memoryToolBar.add(binaryRadioButton);

        radixButtonGroup.add(octRadioButton);
        org.openide.awt.Mnemonics.setLocalizedText(octRadioButton, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.octRadioButton.text")); // NOI18N
        octRadioButton.setFocusable(false);
        octRadioButton.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        octRadioButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        octRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                octRadioButtonActionPerformed(evt);
            }
        });
        memoryToolBar.add(octRadioButton);

        radixButtonGroup.add(decRadioButton);
        org.openide.awt.Mnemonics.setLocalizedText(decRadioButton, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.decRadioButton.text")); // NOI18N
        decRadioButton.setFocusable(false);
        decRadioButton.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        decRadioButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        decRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decRadioButtonActionPerformed(evt);
            }
        });
        memoryToolBar.add(decRadioButton);

        radixButtonGroup.add(hexRadioButton);
        hexRadioButton.setSelected(true);
        org.openide.awt.Mnemonics.setLocalizedText(hexRadioButton, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.hexRadioButton.text")); // NOI18N
        hexRadioButton.setFocusable(false);
        hexRadioButton.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        hexRadioButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        hexRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hexRadioButtonActionPerformed(evt);
            }
        });
        memoryToolBar.add(hexRadioButton);

        memory.add(memoryToolBar, java.awt.BorderLayout.PAGE_START);

        memoryTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "Offset", "0", "1", "2", "3", "4", "5", "6", "7", "String"
            }
        ));
        memoryTable.setMaximumSize(new java.awt.Dimension(80, 80));
        memoryScrollPane.setViewportView(memoryTable);
        if (memoryTable.getColumnModel().getColumnCount() > 0) {
            memoryTable.getColumnModel().getColumn(0).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title0_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(1).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title9")); // NOI18N
            memoryTable.getColumnModel().getColumn(2).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title1_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(3).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title2_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(4).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title3_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(5).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title4_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(6).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title5_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(7).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title6_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(8).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title7_2")); // NOI18N
            memoryTable.getColumnModel().getColumn(9).setHeaderValue(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memoryTable.columnModel.title8_2")); // NOI18N
        }

        memory.add(memoryScrollPane, java.awt.BorderLayout.CENTER);

        memoryTabbedPane.addTab(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.memory.TabConstraints.tabTitle"), memory); // NOI18N

        searchMemory.setLayout(new java.awt.BorderLayout());

        searchMemoryToolBar.setRollover(true);

        org.openide.awt.Mnemonics.setLocalizedText(searchMemoryHexDecString, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemoryHexDecString.text")); // NOI18N
        searchMemoryToolBar.add(searchMemoryHexDecString);

        org.openide.awt.Mnemonics.setLocalizedText(searchMemoryFrom, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemoryFrom.text")); // NOI18N
        searchMemoryToolBar.add(searchMemoryFrom);

        searchMemoryScrollPaneToolBar.setMaximumSize(new java.awt.Dimension(100, 100));
        searchMemoryScrollPaneToolBar.setViewportView(searchMemoryTextPane);

        searchMemoryToolBar.add(searchMemoryScrollPaneToolBar);

        searchMemoryComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        searchMemoryComboBox.setMaximumSize(new java.awt.Dimension(100, 32767));
        searchMemoryToolBar.add(searchMemoryComboBox);

        org.openide.awt.Mnemonics.setLocalizedText(searchMemoryTo, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemoryTo.text")); // NOI18N
        searchMemoryToolBar.add(searchMemoryTo);

        searchMemoryComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        searchMemoryComboBox2.setMaximumSize(new java.awt.Dimension(100, 32767));
        searchMemoryToolBar.add(searchMemoryComboBox2);

        org.openide.awt.Mnemonics.setLocalizedText(searchMemorySearch, org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemorySearch.text")); // NOI18N
        searchMemorySearch.setFocusable(false);
        searchMemorySearch.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        searchMemorySearch.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        searchMemorySearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchMemorySearchActionPerformed(evt);
            }
        });
        searchMemoryToolBar.add(searchMemorySearch);

        searchMemory.add(searchMemoryToolBar, java.awt.BorderLayout.PAGE_START);

        searchMemoryTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Physical address", "Bytes", "String"
            }
        ));
        searchMemoryScrollPane.setViewportView(searchMemoryTable);

        searchMemory.add(searchMemoryScrollPane, java.awt.BorderLayout.CENTER);

        memoryTabbedPane.addTab(org.openide.util.NbBundle.getMessage(MemoryTopComponent.class, "MemoryTopComponent.searchMemory.TabConstraints.tabTitle"), searchMemory); // NOI18N

        add(memoryTabbedPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void searchMemorySearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchMemorySearchActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_searchMemorySearchActionPerformed

    private void searchMemoryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchMemoryButtonActionPerformed
		String addr = searchMemoryTextField.getText();
		Simulator.getSimulator().updateMemory(addr);
//        memoryTableModel.fireTableDataChanged();
    }//GEN-LAST:event_searchMemoryButtonActionPerformed

    private void searchMemoryTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_searchMemoryTextFieldKeyPressed
		if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
			searchMemoryButtonActionPerformed(null);
		}
    }//GEN-LAST:event_searchMemoryTextFieldKeyPressed

    private void binaryRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_binaryRadioButtonActionPerformed
//        MemoryTableCellRenderer renderer = (MemoryTableCellRenderer) memoryTable.getDefaultRenderer(String.class);
//        renderer.radix = 2;
//		memoryTableModel.fireTableDataChanged();
		Simulator.getSimulator().radix = 2;
		Simulator.getSimulator().updateMemory(Simulator.getSimulator().address);
    }//GEN-LAST:event_binaryRadioButtonActionPerformed

    private void octRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_octRadioButtonActionPerformed
//         MemoryTableCellRenderer renderer = (MemoryTableCellRenderer) memoryTable.getDefaultRenderer(String.class);
//        renderer.radix = 8;
//        memoryTableModel.fireTableDataChanged();
		Simulator.getSimulator().radix = 8;
		Simulator.getSimulator().updateMemory(Simulator.getSimulator().address);
    }//GEN-LAST:event_octRadioButtonActionPerformed

    private void decRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decRadioButtonActionPerformed
//       MemoryTableCellRenderer renderer = (MemoryTableCellRenderer) memoryTable.getDefaultRenderer(String.class);
//        renderer.radix = 10;
//        memoryTableModel.fireTableDataChanged();
		Simulator.getSimulator().radix = 10;
		Simulator.getSimulator().updateMemory(Simulator.getSimulator().address);
    }//GEN-LAST:event_decRadioButtonActionPerformed

    private void hexRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hexRadioButtonActionPerformed
//         MemoryTableCellRenderer renderer = (MemoryTableCellRenderer) memoryTable.getDefaultRenderer(String.class);
//        renderer.radix = 16;
//		     memoryTableModel.fireTableDataChanged();
		Simulator.getSimulator().radix = 16;
		Simulator.getSimulator().updateMemory(Simulator.getSimulator().address);
    }//GEN-LAST:event_hexRadioButtonActionPerformed

    private void searchMemoryTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchMemoryTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_searchMemoryTextFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JRadioButton binaryRadioButton;
    public javax.swing.JRadioButton decRadioButton;
    public javax.swing.JRadioButton hexRadioButton;
    private javax.swing.JPanel memory;
    private javax.swing.JScrollPane memoryScrollPane;
    public javax.swing.JTabbedPane memoryTabbedPane;
    public javax.swing.JTable memoryTable;
    private javax.swing.JToolBar memoryToolBar;
    public javax.swing.JRadioButton octRadioButton;
    private javax.swing.ButtonGroup radixButtonGroup;
    private javax.swing.JPanel searchMemory;
    public javax.swing.JButton searchMemoryButton;
    public javax.swing.JComboBox<String> searchMemoryComboBox;
    public javax.swing.JComboBox<String> searchMemoryComboBox2;
    private javax.swing.JLabel searchMemoryFrom;
    private javax.swing.JLabel searchMemoryHexDecString;
    public javax.swing.JScrollPane searchMemoryScrollPane;
    private javax.swing.JScrollPane searchMemoryScrollPaneToolBar;
    public javax.swing.JButton searchMemorySearch;
    private javax.swing.JTable searchMemoryTable;
    private javax.swing.JTextField searchMemoryTextField;
    public javax.swing.JTextPane searchMemoryTextPane;
    private javax.swing.JLabel searchMemoryTo;
    private javax.swing.JToolBar searchMemoryToolBar;
    // End of variables declaration//GEN-END:variables
    @Override
	public void componentOpened() {
		// TODO add custom code on component opening
	}

	@Override
	public void componentClosed() {
		// TODO add custom code on component closing
	}

	void writeProperties(java.util.Properties p) {
		// better to version settings since initial version as advocated at
		// http://wiki.apidesign.org/wiki/PropertyFiles
		p.setProperty("version", "1.0");
		// TODO store your settings
	}

	void readProperties(java.util.Properties p) {
		String version = p.getProperty("version");
		// TODO read your settings according to their version
	}

	public void writeMemory(String mem, String content) {
	}
}
